/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.tables.records.VDataquierMissinglistQsRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDataquierMissinglistQs extends TableImpl<VDataquierMissinglistQsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_dataquier_missinglist_qs</code>
     */
    public static final VDataquierMissinglistQs V_DATAQUIER_MISSINGLIST_QS = new VDataquierMissinglistQs();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDataquierMissinglistQsRecord> getRecordType() {
        return VDataquierMissinglistQsRecord.class;
    }

    /**
     * The column <code>common_dd.v_dataquier_missinglist_qs.list</code>.
     */
    public final TableField<VDataquierMissinglistQsRecord, Integer> LIST = createField(DSL.name("list"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier_missinglist_qs.codes</code>.
     */
    public final TableField<VDataquierMissinglistQsRecord, String> CODES = createField(DSL.name("codes"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_missinglist_qs.isocode</code>.
     */
    public final TableField<VDataquierMissinglistQsRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_dataquier_missinglist_qs.stata_codes</code>.
     */
    public final TableField<VDataquierMissinglistQsRecord, String> STATA_CODES = createField(DSL.name("stata_codes"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_missinglist_qs.missingtype</code>.
     */
    public final TableField<VDataquierMissinglistQsRecord, String> MISSINGTYPE = createField(DSL.name("missingtype"), SQLDataType.CLOB, this, "");

    private VDataquierMissinglistQs(Name alias, Table<VDataquierMissinglistQsRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDataquierMissinglistQs(Name alias, Table<VDataquierMissinglistQsRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dataquier_missinglist_qs" as  SELECT mv.fk_missinglist AS list,
          string_agg(((c.num_missingcode || '='::text) || t.value), '|'::text) AS codes,
          t.isocode,
          string_agg((c.num_missingcode)::text, ' '::text) AS stata_codes,
          mc.name AS missingtype
         FROM (((((common_dd.t_core_missingvalue mv
           LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
           LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
           LEFT JOIN common_dd.t_dm_missingcode c ON ((c.pk = dmv.fk_missingcode)))
           LEFT JOIN common_dd.t_core_translation t ON (((t.fk_trans_key = mm.fk_lang) AND (t.category = 'crf'::common_dd.enum_trans_category))))
           LEFT JOIN common_dd.t_core_missingclass mc ON ((mc.pk = mv.fk_missingclass_qs)))
        WHERE (mc.name = ANY (ARRAY['jump'::text, 'missing'::text]))
        GROUP BY mv.fk_missinglist, t.isocode, mc.name;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_missinglist_qs</code> table
     * reference
     */
    public VDataquierMissinglistQs(String alias) {
        this(DSL.name(alias), V_DATAQUIER_MISSINGLIST_QS);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_missinglist_qs</code> table
     * reference
     */
    public VDataquierMissinglistQs(Name alias) {
        this(alias, V_DATAQUIER_MISSINGLIST_QS);
    }

    /**
     * Create a <code>common_dd.v_dataquier_missinglist_qs</code> table
     * reference
     */
    public VDataquierMissinglistQs() {
        this(DSL.name("v_dataquier_missinglist_qs"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDataquierMissinglistQs as(String alias) {
        return new VDataquierMissinglistQs(DSL.name(alias), this);
    }

    @Override
    public VDataquierMissinglistQs as(Name alias) {
        return new VDataquierMissinglistQs(alias, this);
    }

    @Override
    public VDataquierMissinglistQs as(Table<?> alias) {
        return new VDataquierMissinglistQs(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierMissinglistQs rename(String name) {
        return new VDataquierMissinglistQs(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierMissinglistQs rename(Name name) {
        return new VDataquierMissinglistQs(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierMissinglistQs rename(Table<?> name) {
        return new VDataquierMissinglistQs(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglistQs where(Condition condition) {
        return new VDataquierMissinglistQs(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglistQs where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglistQs where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglistQs where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierMissinglistQs where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierMissinglistQs where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierMissinglistQs where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierMissinglistQs where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglistQs whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierMissinglistQs whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
